#ifndef __TJSINSTANCE_H__
#define __TJSINSTANCE_H__

#include "tjsbase.h"

/**
 * ggCX^XێJavaScriptpNX
 * ovg^Cvɓo^܂
 */
class TJSInstance : public TJSBase, iTJSNativeInstance {

public:
	// p
	static void init(Isolate *isolate, Local<ObjectTemplate> &globalTemplate);

	/**
	 * ggIuWFNg Javascrip IuWFNgɕϊ
	 * @param result i[
	 * @param variant ϊ
	 * @return ϊ true
	 */
	static bool getJSObject(Local<Object> &result, const tTJSVariant &variant);

	// \bhĂяop
	static tjs_error getProp(Isolate *isolate, Local<Object> &obj, const tjs_char *membername, tTJSVariant *result);
	static tjs_error setProp(Isolate *isolate, Local<Object> &obj, const tjs_char *membername, const tTJSVariant *param);
	static tjs_error remove(Isolate *isolate, Local<Object> &obj, const tjs_char *membername);
	static tjs_error createMethod(Isolate *isolate, Local<Object> &obj, const tjs_char *membername, iTJSDispatch2 **result, tjs_int numparams, tTJSVariant **param);
	static tjs_error callMethod(Isolate *isolate, Local<Object> &obj, const tjs_char *membername, tTJSVariant *result, tjs_int numparams, tTJSVariant **param, iTJSDispatch2 *objthis);
	
	// ---------------------------------------------------------------

	/**
	 * call p̌
	 * TJSCX^XJavascriptCX^X̃\bh𒼐ڌĂяo
	 */
	static tjs_error call(tjs_uint32 flag, const tjs_char * membername, tjs_uint32 *hint,
						  tTJSVariant *result,
						  tjs_int numparams, tTJSVariant **param, iTJSDispatch2 *objthis);
	
	/**
	 * missing p̌
	 * TJSCX^XɃo݂Ȃꍇ JavascriptCX^XQƂ
	 */
	static tjs_error missing(tjs_uint32 flag, const tjs_char * membername, tjs_uint32 *hint,
							 tTJSVariant *result,
							 tjs_int numparams, tTJSVariant **param, iTJSDispatch2 *objthis);

	// ---------------------------------------------------------------
	
	/**
	 * TJSIuWFNgp̃\bh
	 * @param args 
	 * @return 
	 */
	static void tjsInvoker(const FunctionCallbackInfo<Value>& args);

	/**
	 * TJSIuWFNgp̃vpeBQb^[
	 */
	static void tjsGetter(Local<String> property, const PropertyCallbackInfo<Value>& info);
	
	/**
	 * TJSIuWFNgp̃vpeBZb^[
	 */
	static void tjsSetter(Local<String> property, Local<Value> value, const PropertyCallbackInfo<void>& info);

	/**
	 * RXgN^
	 * @param obj ȃIuWFNg
	 * @param instance oChΏۂTJSIuWFNg
	 */
	TJSInstance(Isolate *isolate, Local<Object> &obj, const tTJSVariant &instance);
	
private:

	/**
	 * ggNX Javascript NX𐶐
	 * @param args 
	 * @return 
	 */
	static void createTJSClass(const FunctionCallbackInfo<Value>& args);

	/**
	 * j
	 */
	void invalidate();

	template<class T>
	static void release(const WeakCallbackData<T,TJSInstance>& data) {
		TJSInstance *self = data.GetParameter();
		if (self) {
			self->invalidate();
		}
	}
	
	/**
	 * TJSIuWFNg̗LmF
	 * @param args 
	 * @return 
	 */
	static void tjsIsValid(const FunctionCallbackInfo<Value>& args);

	/**
	 * TJSIuWFNgɑ΂I[oCh
	 * @param args 
	 * @return 
	 */
	static void tjsOverride(const FunctionCallbackInfo<Value>& args);
	
	/**
	 * TJSIuWFNg̃RXgN^
	 * @param args 
	 * @return 
	 */
	static void tjsConstructor(const FunctionCallbackInfo<Value>& args);

	// NativeClass ID
	static int classId;
	
	// ȎQƗp
	Persistent<Object> self;
	Isolate *isolate;

public:
	// NativeInstance Ήpo
	virtual tjs_error TJS_INTF_METHOD Construct(tjs_int numparams, tTJSVariant **param, iTJSDispatch2 *tjs_obj);
	virtual void TJS_INTF_METHOD Invalidate();
	virtual void TJS_INTF_METHOD Destruct();

	Local<Object> getObject() {
		return Local<Object>::New(isolate, self);
	}
};

#endif
